package com.fp.persistence.pgeneral.product;

import javax.persistence.Column;
import java.io.Serializable;
import com.fp.dto.hb.HibernateId;
import java.lang.reflect.Field;
import javax.persistence.Embeddable;
import javax.persistence.Transient;

/**Clase que hace referencia a la Clave Primaria de TGENESUBPRODINSTALLTYPE*/
@Embeddable
public class TgeneSubprodInstallTypeKey  extends com.fp.dto.AbstractDataTransport  implements Serializable,Cloneable,HibernateId{
/**
* HashCode asociado con la Instancia
*/
@Transient
private int hashValue = 0;
/**
* Version de la Clase
*/
private static final long serialVersionUID = 1L;
@Column(name="MODULECODE", nullable=false,updatable=false)

/**
* Codigo de modulo
*/
private String modulecode;

@Column(name="PRODUCTCODE", nullable=false,updatable=false)

/**
* Codigo de producto
*/
private String productcode;

@Column(name="SUBPRODUCTCODE", nullable=false,updatable=false)

/**
* Codigo de subproducto
*/
private String subproductcode;

@Column(name="INSTALLMENTTYPE", nullable=false,updatable=false)

/**
* Codigo de tipo de tabla de amortizacion
*/
private String installmenttype;

/**Contructor por defecto*/
public TgeneSubprodInstallTypeKey(){}
/**Contructor de TgeneSubprodInstallTypeKey
@param pModulecode Codigo de modulo
@param pProductcode Codigo de producto
@param pSubproductcode Codigo de subproducto
@param pInstallmenttype Codigo de tipo de tabla de amortizacion
*/
public TgeneSubprodInstallTypeKey(String pModulecode,String pProductcode,String pSubproductcode,String pInstallmenttype){
 modulecode=pModulecode;
 productcode=pProductcode;
 subproductcode=pSubproductcode;
 installmenttype=pInstallmenttype;
}
/**Obtiene el valor de modulecode
@return valor de modulecode*/
public String getModulecode(){
  return modulecode;
}
/**Fija el valor de modulecode
@param pModulecode nuevo Valor de modulecode*/
public void setModulecode(String pModulecode){
  modulecode=pModulecode;
}

/**Obtiene el valor de productcode
@return valor de productcode*/
public String getProductcode(){
  return productcode;
}
/**Fija el valor de productcode
@param pProductcode nuevo Valor de productcode*/
public void setProductcode(String pProductcode){
  productcode=pProductcode;
}

/**Obtiene el valor de subproductcode
@return valor de subproductcode*/
public String getSubproductcode(){
  return subproductcode;
}
/**Fija el valor de subproductcode
@param pSubproductcode nuevo Valor de subproductcode*/
public void setSubproductcode(String pSubproductcode){
  subproductcode=pSubproductcode;
}

/**Obtiene el valor de installmenttype
@return valor de installmenttype*/
public String getInstallmenttype(){
  return installmenttype;
}
/**Fija el valor de installmenttype
@param pInstallmenttype nuevo Valor de installmenttype*/
public void setInstallmenttype(String pInstallmenttype){
  installmenttype=pInstallmenttype;
}

/**Implementación de la comparación de TgeneSubprodInstallTypeKey
@param o Objeto de comparación
*/
public boolean equals(Object o){
  if (o == null)return false;
  if (! (o instanceof TgeneSubprodInstallTypeKey))return false;
  TgeneSubprodInstallTypeKey that = (TgeneSubprodInstallTypeKey) o;
  if (this.getModulecode() == null || that.getModulecode() == null){
      return false;
  }
  if (! this.getModulecode().equals(that.getModulecode())){
    return false;
  }
  if (this.getProductcode() == null || that.getProductcode() == null){
      return false;
  }
  if (! this.getProductcode().equals(that.getProductcode())){
    return false;
  }
  if (this.getSubproductcode() == null || that.getSubproductcode() == null){
      return false;
  }
  if (! this.getSubproductcode().equals(that.getSubproductcode())){
    return false;
  }
  if (this.getInstallmenttype() == null || that.getInstallmenttype() == null){
      return false;
  }
  if (! this.getInstallmenttype().equals(that.getInstallmenttype())){
    return false;
  }
  return true;
}
/**Implementación del método hashCode bajo el patrón de Bloch
@return hashCode de la instancia TgeneSubprodInstallTypeKey
*/
public int hashCode(){
  if (this.hashValue == 0){
    int result = 17;
    result = result * 37 + (this.getModulecode() == null ? 0 : this.getModulecode().hashCode());
    result = result * 37 + (this.getProductcode() == null ? 0 : this.getProductcode().hashCode());
    result = result * 37 + (this.getSubproductcode() == null ? 0 : this.getSubproductcode().hashCode());
    result = result * 37 + (this.getInstallmenttype() == null ? 0 : this.getInstallmenttype().hashCode());
    this.hashValue = result;
  }
  return this.hashValue;
}
public Object cloneMe() throws CloneNotSupportedException {
  return this.clone();
}
/**Implementación toString
*/
public String toString() {
	Field[]fs=this.getClass().getDeclaredFields();
	String data="";
	for(Field f:fs){
	 try{	
	 String name=f.getName();
   if(f.getType().getName().compareTo("java.util.Set")==0)continue;
	 if(name.compareTo("hashValue")==0||name.compareTo("serialVersionUID")==0)continue;
		data+="pk."+name+"="+f.get(this)+";";
	 }catch(Exception e){
		 continue;
	 }
		}
		if(data.compareTo("")==0){
		data=super.toString();
		}
	return data;
	}
}
